<template>
  <!-- 文件定期审查记录 -->
  <div class="PeriodicDocumentReviewRecords">
    <el-row class="title">
      <el-col :span="12" style="padding-left: 20px;text-align: left;">文件定期审查记录</el-col>
      <!-- <el-col :span="12" style="text-align: right;">
        <el-button size="medium" type="primary" @click="openAdd" v-if="addPower">新增</el-button>
        <el-upload :action="action" :show-file-list="false"
          accept='.doc,.docx' :headers="headers" :on-change="beforeUpload"
          :on-error="onError" ref='upload' v-if="upPower" :on-success="handleSuccessUp" style="display:inline-block;margin-left: 20px;">
          <el-button type="primary" size="medium">导入</el-button></el-upload>
        <el-button size="medium" type="primary" @click="handleDown" :loading="outLoading" v-if="outPower" style="display:inline-block;margin-left: 20px;">导出</el-button>
      </el-col> -->
    </el-row>
    <el-tabs type="border-card" v-model="activeName" style="height: 100%;" @tab-click="tabClick">
      <el-tab-pane label="填写" name="填写" style="height: 100%;">
        <div class="search">
          <div class="search_thing">
            <div class="search_label">文件名称：</div>
            <div class="search_input"><el-input size="small" placeholder="请输入" clearable v-model="componentData.entity.documentName"
                @keyup.enter.native="refreshTable()"></el-input></div>
          </div>
          <div class="search_thing">
            <div class="search_label">文件编号：</div>
            <div class="search_input">
              <el-input size="small" placeholder="请输入" clearable v-model="componentData.entity.documentCode"
                @keyup.enter.native="refreshTable()"></el-input>
            </div>
          </div>
          <div class="search_thing" style="padding-left: 30px;">
            <el-button size="small" @click="refresh()">重 置</el-button>
            <el-button size="small" type="primary" @click="refreshTable()">查 询</el-button>
          </div>
          <div class="btns">
            <el-button size="medium" type="primary" @click="openAdd" v-if="addPower&&!currentInfo.ratifyUserName">新增</el-button>
            <el-upload :action="action" :multiple="false"
              :show-file-list="false"
              accept='.doc,.docx' :headers="headers" :on-change="beforeUpload"
              :on-error="onError" ref='upload' v-if="upPower&&!currentInfo.ratifyUserName" :on-success="handleSuccessUp" style="display:inline-block;margin-left: 20px;">
              <el-button type="primary" size="medium">导入</el-button></el-upload>
          </div>
        </div>
        <div class="table" v-if="activeName=='填写'">
          <ValueTable ref="ValueTable" :url="$api.manageRecordIntervals.pageManageRecordIntervals"
            :delUrl="$api.manageRecordIntervals.delManageRecordIntervals"
            :componentData="componentData" :upUrl="$api.manageRecordIssueRecycle.doManageRecordIssueRecycle" :key="upIndex"/>
        </div>
      </el-tab-pane>
      <el-tab-pane label="历史记录" name="历史记录" style="height: 100%;">
        <div class="search">
          <div class="search_thing">
            <div class="search_label">年：</div>
            <div class="search_input">
              <el-date-picker
                v-model="componentData0.entity.year"
                type="year"
                placeholder="选择年" format="yyyy"
                value-format="yyyy" size="small" @change="refreshTable()">
              </el-date-picker>
            </div>
          </div>
          <div class="search_thing" style="padding-left: 30px;">
            <el-button size="small" @click="refresh(1)">重 置</el-button>
            <el-button size="small" type="primary" @click="refreshTable(1)">查 询</el-button>
          </div>
        </div>
        <div class="table" v-if="activeName=='历史记录'">
          <ValueTable ref="ValueTable0" :url="$api.manageRecordIntervals.pageManageRecordIntervalsTotal"
            :componentData="componentData0" :key="upIndex"/>
        </div>
      </el-tab-pane>
    </el-tabs>
    <el-dialog
      :title="title"
      :visible.sync="addDialogVisible"
      width="400px" top="6vh">
      <el-row>
        <el-col :span="24" style="margin-bottom: 16px;">
          <div class="search_thing">
            <div class="search_label"><span style="color: red;margin-left: 4px;">* </span>文件编号：</div>
            <div class="search_input">
              <el-select v-model="addInfo.documentCode" size="small" style="width: 100%;" @change="getCurrentFile" allow-create clearable filterable>
                <el-option
                  v-for="item in fileList"
                  :key="item.documentCode"
                  :label="item.title"
                  :value="item.documentCode">
                </el-option>
              </el-select>
            </div>
          </div>
        </el-col>
        <el-col :span="24" style="margin-bottom: 16px;">
          <div class="search_thing">
            <div class="search_label">文件名称：</div>
            <div class="search_input"><el-input size="small" placeholder="请输入" clearable v-model="addInfo.documentName"></el-input></div>
          </div>
        </el-col>
        <el-col :span="24" style="margin-bottom: 16px;">
          <div class="search_thing">
            <div class="search_label">版本号：</div>
            <div class="search_input"><el-input size="small" placeholder="请输入" clearable v-model="addInfo.documentVersion"></el-input></div>
          </div>
        </el-col>
        <el-col :span="24" style="margin-bottom: 16px;">
          <div class="search_thing">
            <div class="search_label">修订号：</div>
            <div class="search_input"><el-input size="small" placeholder="请输入" clearable v-model="addInfo.revision"></el-input></div>
          </div>
        </el-col>
        <el-col :span="24" style="margin-bottom: 16px;">
          <div class="search_thing">
            <div class="search_label">适宜性：</div>
            <div class="search_input">
              <el-select v-model="addInfo.suitability" placeholder="请选择" size="small" style="width: 100%;">
                <el-option
                  v-for="item in typeList"
                  :key="item.value"
                  :label="item.label"
                  :value="item.value">
                </el-option>
              </el-select>
            </div>
          </div>
        </el-col>
        <el-col :span="24" style="margin-bottom: 16px;">
          <div class="search_thing">
            <div class="search_label">备注：</div>
            <div class="search_input"><el-input size="small" placeholder="请输入" clearable v-model="addInfo.remark" type="textarea"
              :rows="2"></el-input></div>
          </div>
        </el-col>
      </el-row>
      <span slot="footer" class="dialog-footer">
        <el-button @click="addDialogVisible = false">取 消</el-button>
        <el-button type="primary" @click="handleAdd" :loading="addLoading">确 定</el-button>
      </span>
    </el-dialog>
    <!-- 详情/审核 -->
    <el-dialog
      :title="title0"
      :visible.sync="lookDialogVisible"
      width="800px" top="5vh">
      <filePreview v-if="lookDialogVisible" :fileUrl="javaApi+'/word/'+currentInfo.url"
      :currentFile="{}" style="max-height: 70vh;overflow-y: auto;"/>
      <span slot="footer" class="dialog-footer" v-if="title0=='审核'||title0=='批准'">
        <el-button @click="submitCheck('不通过')" :loading="noCheckLoading">不通过</el-button>
        <el-button type="primary" @click="submitCheck('通过')" :loading="checkLoading">通 过</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
import ValueTable from '../tool/value-table.vue'
import filePreview from '../tool/file-preview.vue'
export default {
  components: {
    ValueTable,
    filePreview
  },
  data() {
    return {
      activeName:'填写',
      title0:'新增',
      addPower:true,
      outPower:true,
      upPower:true,
      outLoading:false,
      addLoading:false,
      lookDialogVisible:false,
      noCheckLoading:false,
      checkLoading:false,
      componentData: {
        entity: {
          documentName: null,
          documentCode: null,
          orderBy: {
            field: 'id',
            order: 'desc'
          }
        },
        isIndex: true,
        showSelect: false,
        select: false,
        // selectMethod: 'handleChangeTask',
        do: [{
          id: 'delete',
          font: '删除',
          type: 'text',
          method: 'doDiy',
        }, {
          id: 'handleEdit',
          font: '修改',
          type: 'text',
          method: 'handleEdit',
          field:[],
        }],
        tagField: {
          // documentType:{
          //   select: []
          // },
          // receiveUserName:{
          //   select: []
          // },
        },
        selectField: {
          // documentType:{
          //   select: []
          // },
          // receiveUserName:{
          //   select: []
          // },
        },
        addUpload:['signatoryUrl'],
        requiredAdd: [],
        requiredUp: [],
        datePicker:['receiveDate'],
        noHead:['signedUserName','signedDate','departLims'],//不参与新增编辑的字段
        needSort: [],
        inputType:''
      },
      componentData0: {
          entity: {
            year: null,
            orderBy: {
              field: 'id',
              order: 'desc'
            }
          },
          isIndex: true,
          showSelect: false,
          select: false,
          do: [{
            id: 'handleLook',
            font: '查看',
            type: 'text',
            method: 'handleLook',
            disabFun: (row, index) => {
						return !row.url
            }
          }, {
            id: 'handleDown0',
            font: '下载',
            type: 'text',
            method: 'handleDown0',
            disabFun: (row, index) => {
						return !row.url
            }
          },
          {
            id: 'handleSubmit',
            font: '提交',
            type: 'text',
            method: 'handleSubmit',
            disabFun: (row, index) => {
						return !!row.submitUserName
            }
          },{
            id: 'handleApproval',
            font: '批准',
            type: 'text',
            method: 'handleApproval',
            disabFun: (row, index) => {
						return !row.submitUserName||!!row.ratifyUserName
            }
          }],
          tagField: {},
          selectField: {},
          requiredAdd: [],
          requiredUp: [],
          needSort: [],
          inputType:''
      },
      entityCopy: {},
      entityCopy0: {},
      upIndex: 0,
      addInfo:{},
      title:'新增',
      addInfo:{},
      addDialogVisible:false,
      fileList:[],
      typeList:[],
      currentInfo:{},
    }
  },
  // 用于上传文件的信息
  computed: {
    headers() {
      return {
        'token': sessionStorage.getItem('token')
      }
    },
    action() {
      return this.javaApi +this.$api.manageRecordIntervals.exportInManageRecordIntervals
    }
  },
  mounted() {
    this.entityCopy = this.HaveJson(this.componentData.entity);
    this.entityCopy0 = this.HaveJson(this.componentData0.entity);
    this.getPower()
    this.getFileList()
    this.selectEnumByCategory()
  },
  methods:{
    getPower(){
      let power = JSON.parse(sessionStorage.getItem('power'))
      let add = false
      let del = false
      let up = false;
      let out = false;
      let submit = false
      let ratify = false
      for (var i = 0; i < power.length; i++) {
        if (power[i].menuMethod == 'addManageRecordIntervals') {
          add = true
        }
        if (power[i].menuMethod == 'delManageRecordIntervals') {
          del = true
        }
        if (power[i].menuMethod == 'exportInManageRecordIntervals') {
          up = true
        }
        if (power[i].menuMethod == 'exportOutManageRecordIntervals') {
          out = true
        }
        if (power[i].menuMethod == 'submitManageRecordIntervalsTotal') {
          submit = true
        }
        if (power[i].menuMethod == 'ratifyManageRecordIntervalsTotal') {
          ratify = true
        }
      }
      if (!ratify) {
        this.componentData0.do.splice(3, 1)
      }
      if (!submit) {
        this.componentData0.do.splice(2, 1)
      }
      if (!add) {
        this.componentData.do.splice(1, 1)
      }
      if (!del) {
        this.componentData.do.splice(0, 1)
      }
      this.addPower = add
      this.outPower = out
      this.upPower = up
    },
    // 新增
    openAdd(){
      // this.$refs.ValueTable.openAddDia(this.$api.manageRecordIssueRecycle.addManageRecordIssueRecycle);
      this.addInfo = {}
      this.title = '新增'
      this.addDialogVisible = true;
    },
    // 导出
    handleDown(){
      this.outLoading = true
      this.$axios.post(this.$api.manageRecordIntervals.exportOutManageRecordIntervals,{entity:this.componentData.entity},{headers: { 'Content-Type': 'application/json' }}).then(res => {
        this.outLoading = false
        if(res.code==201) return this.$message.error('导出失败')
        this.$message.success('导出成功')
        let url = this.javaApi+'word/'+res.message
        const link = document.createElement('a');
        link.href = url;
        link.download = '文件定期审查记录';
        link.click();
      })
    },
    refreshTable(num) {
      if(num){
        this.$refs['ValueTable0'].selectList()
      }else{
        this.$refs['ValueTable'].selectList()
      }
    },
    refresh(num) {
      if(num){
        this.componentData0.entity = this.HaveJson(this.entityCopy0)
        this.upIndex++
      }else{
        this.componentData.entity = this.HaveJson(this.entityCopy)
        this.upIndex++
      }
    },
    beforeUpload(file) {
      if (file.size > 1024 * 1024 * 10) {
        this.$message.error('上传文件不超过10M');
        this.$refs.upload.clearFiles()
        return false;
      } else {
        // this.upLoading = true;
        return true;
      }
    },
    onError(err, file, fileList) {
      this.$message.error('上传失败')
      this.$refs.upload.clearFiles()
    },
    handleSuccessUp(response) {
      this.upLoading = false;
      if (response.code == 200) {
        this.$message.success('上传成功');
        this.$refs['ValueTable'].selectList()
      }else{
        this.$message.error('上传失败');
      }
    },
    getCurrentFile(e){
      let obj = this.fileList.find(m=>m.documentCode==e)
      if(obj){
        this.$set(this.addInfo,'documentName',obj.name)
        this.$set(this.addInfo,'documentVersion',obj.version)
        // this.addInfo.documentName = obj.name
        // this.addInfo.documentVersion = obj.version
      }
    },
    // 获取文件列表--文件清单
    getFileList(){
      this.$axios.post(this.$api.manageDocumentList.pageManageDocumentList,{
        entity: {
          orderBy: {
            field: 'id',
            order: 'asc'
          }
        },
        page:{
          current:-1,
          size:-1
        }
      },{headers: {
        'Content-Type': 'application/json'
      }}).then(res=>{
        this.fileList = res.data.body.records.map(m=>{
          m.title = m.documentCode
          return m
        })
      }).catch(err=>{})
    },
    selectEnumByCategory() {
      this.$axios.post(this.$api.enums.selectEnumByCategory, {
        category: "适宜性"
      }).then(res => {
        this.typeList = res.data
      })
    },
    // 提交
    handleAdd(){
      if(!this.addInfo.documentCode) return this.$message.error('请输入文件编号')
      this.addLoading = true
      let obj = {}
      if(this.title=='新增'){
        obj = this.HaveJson(this.addInfo)
      }else{
        let {id,documentCode,documentName,documentVersion,revision,suitability,remark} = this.addInfo
        obj = {id,documentCode,documentName,documentVersion,revision,suitability,remark}
      }
      this.$axios.post(this.$api.manageRecordIntervals[this.title=='新增'?'addManageRecordIntervals':'doManageRecordIntervals'], obj,{headers: { 'Content-Type': 'application/json' },noQs:true}).then(res => {
          this.addLoading = false
          if (res.code == 201) {
            return
          }
          this.addDialogVisible = false
          this.$message({
            type: 'success',
            message: '操作成功!'
          });
          this.refreshTable()
        }).catch(err => {})
    },
    // 修改
    handleEdit(row){
      this.addInfo = row
      this.title = '编辑'
      this.addDialogVisible = true;
    },
    submitCheck(state){
      if(state=='通过'){
        this.checkLoading = true
      }else{
        this.noCheckLoading = true
      }
      this.$axios.post(this.$api.manageRecordIntervals.ratifyManageRecordIntervalsTotal,{
        id:this.currentInfo.id,
        ratifyState:state
      }).then(res=>{
        this.checkLoading = false
        if(res.code==201){
          return
        }
        this.noCheckLoading = false
        this.$message({
          type: 'success',
          message: '操作成功!'
        });
        this.$refs['ValueTable0'].selectList()
        this.lookDialogVisible = false
      }).catch(err=>{});
    },
    // 查看
    handleLook(row){
      this.title0 = '查看'
      this.commonFun(row)
    },
    commonFun(row,callbanck){
      this.currentInfo = row
      this.lookDialogVisible = true
      if(callbanck){
        callbanck()
      }
    },
    handleDown0(row){
      let url = this.javaApi+'word/'+row.url
      const link = document.createElement('a');
      link.href = url;
      link.download = row.month+' 所有文件定期检查记录';
      link.click();
    },
    // 提交
    handleSubmit(row){
      this.$confirm('是否提交 '+row.year+' 年的数据', '提交', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        this.$axios.post(this.$api.manageRecordIntervals.submitManageRecordIntervalsTotal,{
          id:row.id
        }).then(res=>{
          if (res.code === 201) return
          this.$message({
            type: 'success',
            message: '提交成功!'
          });
          this.$refs['ValueTable0'].selectList()
        }).catch(err=>{});
      })
    },
    // 批准
    handleApproval(row){
      this.title0 = '批准'
      this.commonFun(row)
    },
    tabClick(e){
      if(e.index==0){
        this.currentInfo = this.$refs['ValueTable0'].tableData[0]
      }
    }
  }
}
</script>

<style scoped>
.title {
    height: 60px;
    line-height: 60px;
  }
  .search {
    background-color: #fff;
    height: 40px;
    display: flex;
    align-items: center;
    position: relative;
  }

  .search_thing {
    width: 350px;
    display: flex;
    align-items: center;
  }

  .search_label {
    width: 110px;
    font-size: 14px;
    text-align: right;
  }

  .search_input {
    width: calc(100% - 110px);
  }

  .table {
    margin-top: 10px;
    background-color: #fff;
    width: calc(100% - 40px);
    height: calc(100% - 60px - 140px);
    padding: 20px;
  }
  >>>.el-tabs__content{
    height: 100%;
  }
  .btns{
    position: absolute;
    right: 20px;
    top: 5px;
  }
</style>
